 === Script Information Header ===
' Script Name: PurgeTemp.vbs
' Date:        18.10.09
' Author:       
' Description:     

' === Initialization Block ===
Option Explicit
On Error Resume Next
Dim aExceptions(3)
Dim sProgramFiles, sWinDir, sWinTempFolder, sDocuments, sLogFileName, sQuarantine
Dim bFlag, sException
Dim oShell, oFSO, oLogFile, oDocuments, colProfiles, oProfile
Const PurgeTime = 14

' ==== Script Main Logic ====
'   
Set oShell = CreateObject("WScript.Shell")
'    
Set oFSO = CreateObject("Scripting.Filesystemobject")
'  -  ,    
aExceptions(0) = "Default User"
aExceptions(1) = "LocalService"
aExceptions(2) = "NetworkService"
aExceptions(3) = "All Users"
'    
sProgramFiles = oShell.ExpandEnvironmentStrings("%ProgramFiles%")
sWinDir = oShell.ExpandEnvironmentStrings("%WinDir%")
sWinTempFolder = sWinDir & "\Temp"
sDocuments = "C:\Documents and Settings"
'    
sLogFileName = sWinTempFolder & "\PurgeTemp_" & Date
sLogFileName = Replace(sLogFileName, ".", "_")
sLogFileName = Replace(sLogFileName, "/", "_")
Set oLogFile = oFSO.CreateTextFile(sLogFileName & ".log",true)
oLogFile.WriteLine "========== Start purging =========="
'    Windows
oLogFile.WriteLine vbCrLf & "========== Windows Temporary folder =========="
PurgeFolder(sWinTempFolder)
'        
oLogFile.WriteLine vbCrLf & _ 
  "========== Users Temporary folder and Users Temporary Internet Files =========="
Set oDocuments = oFSO.GetFolder(sDocuments)
Set colProfiles = oDocuments.SubFolders
For Each oProfile In colProfiles
    bFlag = false
    For Each sException in aExceptions
        if InStr(oProfile.Path,sException) > 0 then
        bFlag = true
            exit for
        end if
    Next
    If bFlag = False Then
        PurgeFolder(oProfile.Path & "\Local Settings\Temp")
        PurgeFolder(oProfile.Path & "\Local Settings\Temporary Internet Files")
    End If
Next
'   NOD32
oLogFile.WriteLine vbCrLf & "========== NOD32 Quarantine =========="
sQuarantine = sProgramFiles & "\Eset\Infected"
PurgeFolder(sQuarantine)
'   
oLogFile.WriteLine vbCrLf & "========== Stop purging =========="
oLogFile.Close

' === Functions and Procedures ===
'  PurgeFolder -   
Sub PurgeFolder(sFolderPath)
    Dim oFolder, colFiles, oFile, colSubFolders, oSubFolder
    '   Folder
    Set oFolder = oFSO.GetFolder(sFolderPath)
    '   
    Set colFiles = oFolder.Files
    '     
    For each oFile in colFiles
        ' ,    
        If (Date-oFile.DateLastModified) > PurgeTime and (Date-oFile.DateCreated) > _ 
          PurgeTime Then
            '     
            oLogFile.Writeline oFile.Path & vbTab & oFile.DateCreated
            '   
            oFSO.DeleteFile oFile.Path, True
            '    
            if err.Number <> 0 then
                '       
                oLogFile.Writeline "-----> Error # " & CStr(Err.Number) _
                  & " " & Err.Description
                '  
                Err.Clear
            end if
            '   20 
            WScript.Sleep 20
        End if
    Next
    '   
    Set colSubFolders = oFolder.SubFolders
    '   
    For Each oSubFolder In colSubFolders
        '       -  
        '  
        PurgeFolder(oSubFolder.Path)
        '   
        If oSubFolder.Size = 0 Then
            '     
            oLogFile.Writeline oSubFolder.Path & vbTab & oSubFolder.DateCreated
            '   
            oFSO.DeleteFolder oSubFolder.Path
            '    
            If err.Number <> 0 then
                '       
                oLogFile.Writeline "-----> Error # " & CStr(Err.Number) _
                  & " " & Err.Description
                '  
                Err.Clear
            End if
        End if
    Next
End Sub