' === Script Information Header ===
' Script Name: GetADObjects.vbs
' Date:        19.10.09
' Author:       
' Description:   ,     Active Directory
' === Initialization Block ===

Const ADS_UF_ACCOUNTDISABLE             = &H00000002
Const ADS_GROUP_TYPE_GLOBAL_GROUP       = &H2
Const ADS_GROUP_TYPE_DOMAIN_LOCAL_GROUP = &H4
Const ADS_GROUP_TYPE_UNIVERSAL_GROUP    = &H8
Const ADS_GROUP_TYPE_SECURITY_ENABLED   = &H80000000
 
Dim aTemp()
' === Script Main Logic ===

mWorkDir = Left(WScript.ScriptFullName,Len(WScript.ScriptFullName)-Len(WScript.ScriptName))

'   
Set oShell = CreateObject("WScript.Shell")
'    
Set oFSO = CreateObject("Scripting.Filesystemobject")
'     Active Directory
Set oADConection = CreateObject("ADODB.Connection")
'      Active Directory
Set oADCommand = CreateObject("ADODB.Command")
'    Active Directory
oADConection.Provider = "ADsDSOObject"
oADConection.Open
oADCommand.ActiveConnection = oADConection
'     
oADCommand.CommandText = "<LDAP://CN=Users;DC=domain,DC=com>;" & _
  "(objectClass=user);samAccountName,userPrincipalName,displayName," & _
  "name,sn,GivenName,MiddleName,initials,company,department,title," & _
  "telephoneNumber,otherTelephone,facsimileTelephoneNumber," & _
  "otherFacsimileTelephoneNumber,mail,mailNickname,info," & _
  "physicalDeliveryOfficeName,roomNumber,memberOf,ScriptPath," & _
  "HomeDirectory,HomeDrive,ProfilePath;SubTree"
'    
Set oUsers = oADCommand.Execute()
iCounter = 0
ReDim aTemp(0)
'   
Do Until oUsers.EOF
    ReDim Preserve aTemp(iCounter)
    aTemp(iCounter) = oUsers("samAccountName") & vbTab _
      & oUsers("userPrincipalName") & vbTab _
      & oUsers("displayName") & vbTab _
      & oUsers("name") & vbTab _
      & oUsers("sn") & vbTab _
      & oUsers("GivenName") & vbTab _
      & oUsers("MiddleName") & vbTab _
      & oUsers("initials") & vbTab _
      & oUsers("company") & vbTab _
      & oUsers("department") & vbTab _
      & oUsers("title") & vbTab _
      & oUsers("telephoneNumber") & vbTab _
      & oUsers("facsimileTelephoneNumber") & vbTab _
      & oUsers("otherFacsimileTelephoneNumber") & vbTab _
      & oUsers("mail") & vbTab _
      & oUsers("mailNickname") & vbTab _
      & oUsers("info") & vbTab _
      & oUsers("physicalDeliveryOfficeName") & vbTab _
      & oUsers("roomNumber") & vbTab _
      & oUsers("ScriptPath") & vbTab _
      & oUsers("HomeDirectory") & vbTab _
      & oUsers("HomeDrive") & vbTab _
      & oUsers("ProfilePath") & vbCrLf
	oUsers.MoveNext
	iCounter = iCounter + 1
Loop
'   
Call SortArray(aTemp)
'   
mUsers ="samAccountName" & vbTab & _
  "userPrincipalName" & vbTab & _
  "displayName" & vbTab & _
  "name" & vbTab & _
  "sn" & vbTab & _
  "GivenName" & vbTab & _
  "MiddleName" & vbTab & _
  "initials" & vbTab & _
  "company" & vbTab & _
  "department" & vbTab & _
  "title" & vbTab & _
  "telephoneNumber" & vbTab & _
  "facsimileTelephoneNumber" & vbTab & _
  "otherFacsimileTelephoneNumber" & vbTab & _
  "mail" & vbTab & _
  "mailNickname" & vbTab & _
  "info" & vbTab & _
  "physicalDeliveryOfficeName" & vbTab & _
  "roomNumber" & vbTab & _
  "ScriptPath" & vbTab & _
  "HomeDirectory" & vbTab & _
  "HomeDrive" & vbTab & _
  "ProfilePath" & vbCrLf
For iCounter = 0 To UBound(aTemp)
    mUsers = mUsers & aTemp(iCounter)
Next
'     
oADCommand.CommandText = "<LDAP://CN=Computers;DC=domain,DC=com>;" & _
  "(objectClass=Computer);name,operatingSystem,useraccountcontrol;SubTree"
'    
Set oComputers = oADCommand.Execute()
iCounter = 0
ReDim aTemp(0)
'   
Do Until oComputers.EOF
    ReDim Preserve aTemp(iCounter)
    aTemp(iCounter) = oComputers("name") & vbTab _
      & oComputers("operatingSystem") & vbTab
    If Hex(oComputers("UserAccountControl")) and ADS_UF_ACCOUNTDISABLE then
      aTemp(iCounter) = aTemp(iCounter) & "Disabled" & vbCrLf
    Else
        aTemp(iCounter) = aTemp(iCounter) & "Enabled" & vbCrLf
    End If
    oComputers.MoveNext
    iCounter = iCounter + 1
Loop
'   
Call SortArray(aTemp)
'   
mComputers = "Name" & vbTab & _
  "Operating System" & vbTab & _
  "Status" & vbCrLf
For iCounter = 0 To UBound(aTemp)
    mComputers = mComputers & aTemp(iCounter)
Next
'     
oADCommand.CommandText = "<LDAP://CN=Users;DC=domain,DC=com>;" & _
  "(objectClass=group);name,member,memberOf;SubTree"
'    
Set oGroups = oADCommand.Execute()
iCounter = 0
ReDim aTemp(0)
'   
Do until oGroups.EOF
    ReDim Preserve aTemp(iCounter)
    aTemp(iCounter) = aTemp(iCounter) & oGroups("name") & vbCrLf
    aTemp(iCounter) = aTemp(iCounter) & vbTab & "Members:" & vbCrLf
    aMembers = oGroups("member")
    If Not IsNull(aMembers) Then
        For iMember = 0 To UBound(aMembers)
            aTemp(iCounter) = aTemp(iCounter) & vbTab & vbTab & Mid(aMembers(iMember), _
              4,InStr(aMembers(iMember),",")-4) & vbCrLf
        Next
    End if
    aTemp(iCounter) = aTemp(iCounter) & vbTab & "Member of:" & vbCrLf
    aMembers = oGroups("memberOf")
    If Not IsNull(aMembers) Then
        For iMember = 0 To UBound(aMembers)
            aTemp(iCounter) = aTemp(iCounter) & vbTab & vbTab & Mid(aMembers(iMember), _
              4,InStr(aMembers(iMember),",")-4) & vbCrLf
        Next
    End if
    aTemp(iCounter) = aTemp(iCounter) & vbCrLf
    oGroups.MoveNext
    iCounter = iCounter + 1
Loop
'   
Call SortArray(aTemp)
'   
For iCounter = 0 To UBound(aTemp)
    mGroups = mGroups & aTemp(iCounter)
Next
'    
Set oOutFile1 = oFSO.CreateTextFile(mWorkDir & "\" & "Users.txt",1)
Set oOutFile2 = oFSO.CreateTextFile(mWorkDir & "\" & "Computers.txt",1)
Set oOutFile3 = oFSO.CreateTextFile(mWorkDir & "\" & "Groups.txt",1)
oOutFile1.Write mUsers
oOutFile2.Write mComputers
oOutFile3.Write mGroups
oOutFile1.Close
oOutFile2.Close
oOutFile3.Close

' === Functions and Procedures ===
'   
Sub SortArray(byref arrNames)
    For i = (UBound(arrNames) - 1) to 0 Step -1
        For j= 0 to i
            If UCase(arrNames(j)) > UCase(arrNames(j+1)) Then
                strHolder = arrNames(j+1)
                arrNames(j+1) = arrNames(j)
                arrNames(j) = strHolder
            End If
        Next
    Next
End Sub